<?php
// $Id: friendlist_activity.rules.inc,v 1.1 2008/11/09 13:05:43 stalski Exp $ 
// by Jochen Stals - ONE-agency - www.one-agency.be


# ACTIONS

/**
 * Implementation of hook_rules_action_info().
 * @ingroup rules
 */
function friendlist_activity_rules_action_info() {
  $info = array(
    'rules_friendlist_activity_action' => array(
      'label' => t('Logs relational friendlist activity'),
      'eval input' => array(
        'uid_param',
        'uid_target_param',
        'message_param',
        'variables_param'
      ),
      'help' => 'Create a relation between users by logging their activities',
      'module' => 'User activity',
    ),
  );
  return $info;
}

/**
 * Action drupal message configuration form.
 */
function rules_friendlist_activity_action_form($settings, &$form) {
  $settings += array(
    'uid_param' => '', 
    'uid_target_param' => '', 
    'message_param' => '', 
    'variables_param' => ''
  );
  $form['settings']['uid_param'] = array(
    '#type' => 'textfield',
    '#size' => '15',
    '#maxsize' => '25',
    '#title' => t('User'),
    '#default_value' => $settings['uid_param'],
    '#description' => t('The user doing the activity'),
  );
  $form['settings']['uid_target_param'] = array(
    '#type' => 'textfield',
    '#size' => '15',
    '#maxsize' => '25',
    '#title' => t('User target'),
    '#default_value' => $settings['uid_target_param'],
    '#description' => t('The user target of the activity'),
  );
  $form['settings']['message_param'] = array(
    '#type' => 'textfield',
    '#size' => '250',
    '#maxsize' => '250',
    '#title' => t('The message'),
    '#default_value' => $settings['message_param'],
    '#description' => t('The message'),
  );
  $form['settings']['variables_param'] = array(
    '#type' => 'textarea',
    '#title' => t('The variables area.'),
    '#default_value' => $settings['variables_param'],
    '#description' => t('The variables, leave empty or use with care! <br /> Extra modular stuff goes here with the synthax:<br /><b>var1:value1;var2:value2;va</b> ...'),
  );
}

/**
 * Action Implementation: Log an activity
 *
 * @param array $settings
 * @param array form
 * @param array with two arrays (set_info and variables)
 * @ToDo  figure out what params mean / can do
 */
function rules_friendlist_activity_action($settings, $form=array(), $event_info=array()){
  //dsm(func_get_args());  
  $data = array();
  $data['uid'] = $settings['uid_param'];
  $data['uid_target'] = $settings['uid_target_param'];
  $data['message'] = $settings['message_param'];
  $data['variables'] = $settings['variables_param'];
  $event = '';
  if(isset($event_info['set_info']['label']) ){
    $data['event'] = $event_info['set_info']['label'];
  }
  user_activity_log($data); 
}