<?php

// $Id: friendlist_activity.rules_defaults.inc,v 1.1 2008/11/09 13:05:43 stalski Exp $

/**
 * @file
 * Rules' pre-configured rules.
 */

function friendlist_activity_rules_defaults() {  
  $config['rules'] = array();
  $config['rules'] += friendlist_activity_default();
  // dsm('friendlist_activity_rules_defaults');
  return $config;
}

/**
 * Function to work with rules defined in friendlist
 */
function friendlist_activity_default(){
  // Friendlist
  // Add an action to the existing event "event_friendlist_add",
  // for a user relation TWO_WAY user1 -> user2
  $config['friendlist_activity_rule_1_2'] = array(
    '#type' => 'rule',
    '#set' => 'event_friendlist_add',
    '#label' => 'UserActivity - log requester: Friendlist Request accepted',
    '#active' => 1,
    '#weight' => '3',
    '#status' => 'default',
    '#conditions' => array(),
    '#actions' => array(),
  );
  $config['friendlist_activity_rule_1_2']['#conditions'] = array(
    1 => array(
      '#weight' => 0,
      '#settings' =>array(
        'status_param' => 'TW_BOTH',
        '#argument map' => array(
          'status_post' => 'relation_status',
        ),
      ),
      '#info' => array(
        'label' => 'Request has been accepted',
        'label callback' => FALSE,
        'arguments' => array(
          'relation_status' => array(
            'label' => 'Relation status',
            'type' => 'relation_status',
            'description' => 'The relation to compare',
          ),
        ),
        'help' => 'TRUE is returned if the relation status equals the string in the input box',
        'module' => 'Friendlist Rules',
      ),
      '#name' => 'rules_condition_relation_status_compare',
      '#type' => 'condition',
    ),
  );
  $config['friendlist_activity_rule_1_2']['#actions'][0] = array(
    '#weight' => 0,
    '#type' => 'action',
    '#name' => 'friendlist_activity_rules_action',
    '#info' => array(
      'label' => t('Logs relational user activity'),
      'eval input' => array(
        'uid_param',
        'uid_target_param',
        'message_param'
      ),
      'help' => 'Create a relation between users by logging their activities',
      'module' => 'User activity',
    ),
    '#settings' => array(
      'uid_param' => '[user1:uid]',
      'uid_target_param' => '[user2:uid]',
      'message_param' => t('[user1:user] is now [rtid:name_p] with [user2:user].'),
      '#argument map' => array('user2' => 'user'),
      '#eval input' => array(
        'token_rules_input_evaluator' => array(
          'uid_param' => array(0 => 'user1'),  
          'uid_target_param' => array(0 => 'user2'),          
          'message_param' => array(
            0 => 'user1',
            1 => 'rtid',
            2 => 'user2',
          ),
        ),
      ),
    )         
  );  
  // Add an action to the existing event "event_friendlist_add",
  // for a user relation TWO_WAY user2 -> user1
  $config['friendlist_activity_rule_2_1'] = array(
    '#type' => 'rule',
    '#set' => 'event_friendlist_add',
    '#label' => 'UserActivity - log requestee: Friendlist Request accepted',
    '#active' => 1,
    '#weight' => '3',
    '#status' => 'default',
    '#conditions' => array(),
    '#actions' => array(),
  );
  $config['friendlist_activity_rule_2_1']['#conditions'] = array(
    1 => array(
      '#weight' => 0,
      '#settings' =>array(
        'status_param' => 'TW_BOTH',
        '#argument map' => array(
          'status_post' => 'relation_status',
        ),
      ),
      '#info' => array(
        'label' => 'Request has been accepted',
        'label callback' => FALSE,
        'arguments' => array(
          'relation_status' => array(
            'label' => 'Relation status',
            'type' => 'relation_status',
            'description' => 'The relation to compare',
          ),
        ),
        'help' => 'TRUE is returned if the relation status equals the string in the input box',
        'module' => 'Friendlist Rules',
      ),
      '#name' => 'rules_condition_relation_status_compare',
      '#type' => 'condition',
    ),
  );
  $config['friendlist_activity_rule_2_1']['#actions'][0] = array(
    '#weight' => 0,
    '#type' => 'action',
    '#name' => 'rules_action_user_activity',
    '#info' => array(
      'label' => t('Logs relational user activity'),
      'eval input' => array(
        'uid_param',
        'uid_target_param',
        'message_param'
      ),
      'help' => 'Create a relation between users by logging their activities',
      'module' => 'User activity',
    ),
    '#settings' => array(
      'uid_param' => '[user2:uid]',
      'uid_target_param' => '[user1:uid]',
      'message_param' => t('[user2:user] is now [rtid:name_p] with [user1:user].'),
      '#argument map' => array('user1' => 'user'),
      '#eval input' => array(
        'token_rules_input_evaluator' => array(
          'uid_param' => array(0 => 'user2'),  
          'uid_target_param' => array(0 => 'user1'),          
          'message_param' => array(
            0 => 'user2',
            1 => 'rtid',
            2 => 'user1',
          ),
        ),
      ),
    )         
  );  
  //dsm($config);
  return $config;
}